% Locally D-optimal for Example 6 (Magnusdottir,2013)
% Two-model y1=emax*x/ed50+x; y2=smax*x/sd50+x;
% Express as y1=a1*x/b1+x; y2=a2*x/b2+x;
% design space is [0,500]
% CVX
clear;
N=10001;

% parameter value
alpha1=1; %emax
alpha2=1; %smax
beta1=1;  %ed50
beta2=2;  %sd50

% sigma0
r12=0.5; %rho
sig1=1; %sigma1^2
sig2=1; %sigma2^2
sigma=[sig1 r12;r12 sig2];
invs=inv(sigma);

a=0; %lower bound for design space S
b=500;  %upper bound for design space S

u=zeros(1,N); %initial value for design points
for i=1:N
    u(1,i)=a+(i-1)*(b-a)/(N-1);
end

% r=2 is the number of response model
% q=q1+q2=2+2=4 is the number of parameters in total
U=zeros(2,4,N);
G=zeros(4,4,N);
% construct Uj j=1,...,N.
for i=1:N
    U(1,1:2,i)=[u(i)/(u(i)+beta1) -alpha1*u(i)/(u(i)+beta1)^2];
    U(2,3:4,i)=[u(i)/(u(i)+beta2) -alpha2*u(i)/(u(i)+beta2)^2];
    G(:,:,i)=U(:,:,i)'*invs*U(:,:,i);
end

% cvx
cvx_begin
   cvx_precision high
   variable w(N);
   expression H(4,4);  %target function
   
   %get H
   for i=1:N
    H=H+G(:,:,i)*w(i);
   end
   
   minimize (-det_rootn(H))
   subject to
           sum(w)==1;
           w>=0;
cvx_end
design=[u([find(w>0.0009)]);w(find(w>0.0009))']
